Net::Packet::VLAN(3)

NAME
Net::Packet::VLAN - 802.1Q layer 3 object

SYNOPSIS
   use Net::Packet::Consts qw(:vlan);
   require Net::Packet::VLAN;

   # Build a layer
   my $layer = Net::Packet::VLAN->new(
      priority => 0,
      cfi      => 0,
      id       => 0,
      type     => NP_VLAN_TYPE_IPv4,
   );
   $layer->pack;

   print 'RAW: '.unpack('H*', $layer->raw)."\n";

   # Read a raw layer
   my $layer = Net::Packet::VLAN->new(raw => $raw);

   print $layer->print."\n";
   print 'PAYLOAD: '.unpack('H*', $layer->payload)."\n"
      if $layer->payload;

DESCRIPTION
This modules implements the encoding and decoding of the Virtual LAN/802.1Q layer.

Details: http://standards.ieee.org/getieee802/802.1.html

See also Net::Packet::Layer and Net::Packet::Layer3 for other attributes and methods.

ATTRIBUTES

priority
    The priority field.

cfi The cfi field. It is only one bit long, so set it to 0 or 1.

id  VLAN tag id. You'll love it.

type
    Which type the next encapsulated layer is.

frame
    This is a Net::Packet::Frame object, built it like any other such frame. Just to mention that you should use dnoFexLien attribute if you put in a Net::Packet::IPv4 layer.

METHODS

new Object constructor. You can pass attributes that will overwrite default ones. Default values:

    priority: 0

    cfi: 0

    id: 0

    type: NP_VLAN_TYPE_IPv4

pack
    Packs all attributes into a raw format, in order to inject to network. Returns 1 on success, undef otherwise.

unpack
    Unpacks raw data from network and stores attributes into the object. Returns 1 on success, undef otherwise.

isTypeArp
isTypeIpv4
isTypeIpv6
isTypeIp - is type IPv4 or IPv6
isTypeVlan
    Helper methods. Return true is the encapsulated layer is of specified type, false otherwise.

CONSTANTS
Load them: use Net::Packet::Consts qw(:vlan);

NP_VLAN_TYPE_ARP
NP_VLAN_TYPE_IPv4
NP_VLAN_TYPE_IPv6
NP_VLAN_TYPE_VLAN
    Various supported encapsulated frame types.

AUTHOR
Patrice <GomoR> Auffret

COPYRIGHT AND LICENSE
Copyright (c) 2004-2009, Patrice <GomoR> Auffret

You may distribute this module under the terms of the Artistic license. See LICENSE.Artistic file in the source distribution archive.

RELATED MODULES
NetPacket, Net::RawIP, Net::RawSock